#!/bin/sh
# usage: copydist.sh distdir srcs
#
# Each of the {srcs} specifies a directory relative to the cwd.
# It will be unpacked inside the new directory ./$Pa
#

AddB=
if [ "$1" = "-add" ] ; then
    shift; AddB=1
fi
DISTDIR=$1; shift
SRCDIRS=$*

if [ "$DISTDIR" = "" -o "$SRCDIRS" = "" ] ; then
    echo "usage: copydist.sh distdir srcdirs ..."
    exit 1
fi
Version=${Version-1.0}

if [ "$AddB" = "" ] ; then
    if [ -f $DISTDIR -o -d $DISTDIR -o -r $DISTDIR ] ; then
	echo The distribution directory already exists: $DISTDIR
	echo Remove it and try again.
	exit 1
    fi
fi

mkdir -p $DISTDIR
if [ ! -d $DISTDIR ] ; then
    echo Couldnt make the distribution directory: $DISTDIR
    exit 1
fi

EXCEPTLIST=/tmp/ec$$

for x in $SRCDIRS; do
    if [ ! -d $x ] ; then
	echo "Not a directory: $x: skipping..."
	continue
    fi
    XDIR=`dirname $x`
    XBASE=`basename $x`
    rm -f $EXCEPTLIST; touch $EXCEPTLIST
    (cd $XDIR; find $XBASE \( -name 'sun4*' -o -name 'mips*' \
      -o -name '[jJ]unk*' -o -name '#*' -o -name '*.old' \
      -o -name RCS -o -name SCCS \) -print >> $EXCEPTLIST )
    ( cd $XDIR; find $XBASE -type d -name '*test' -print \
      | sed -e 's+/\([^/]*\)$+/\1/\1+' >> $EXCEPTLIST )
    (cd $XDIR ; tar cfFFX - $EXCEPTLIST $XBASE ) | ( cd $DISTDIR ; tar xvf - )
done
