#if !defined(_EEMPOLY_H_)
#define _EEMPOLY_H_ 1
/* 
    RCS: $Header: /vol/cooley/cooley1/kennard/src/eem/RCS/eemPoly.h,v 1.17 93/08/27 14:29:19 kennard Exp $
    Author: Mei-Tjng Huang & Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/

#if !defined(_TOPVEC_H_) && __TOP_AUTOINCLUDE__
#include "topVec.h"
#endif
#if !defined(_EEMCPLX_H_) && __TOP_AUTOINCLUDE__
#include "eemCplx.h"
#endif
#if !defined(_EEMSILAR_H_) && __TOP_AUTOINCLUDE__
#include "eemSilar.h"
#endif

typedef struct _EEMPolyCplx EEMPolyCplx;
struct _EEMPolyCplx {
    TOPVector		Coef;		/* of EEMComplex */
};

#define EEM_POLYCPLX_Vec(pPoly)		(&(pPoly)->Coef)
#define EEM_POLYCPLX_Num(pPoly)		TOPVEC_Num(&(pPoly)->Coef)
#define EEM_POLYCPLX_Get(pPoly,i)	TOPVEC_Get(&(pPoly)->Coef,(i),EEMComplex)
#define EEM_POLYCPLX_GetConst(pPoly)	TOPVEC_HEAD(&(pPoly)->Coef,EEMComplex)
#define EEM_POLYCPLX_GetLead(pPoly)	TOPVEC_TAIL(&(pPoly)->Coef,EEMComplex)

#define EEM_POLYCPLX_LOOP_BEGIN(pPoly,pCoef) \
    TOPVEC_LOOP_FORW_BEGIN(&(pPoly)->Coef,EEMComplex,pCoef)
#define EEM_POLYCPLX_LOOP_END() \
    TOPVEC_LOOP_FORW_END()

#define EEM_POLYCPLX_IDX_LOOP_FORW_BEGIN(pPoly,idx,pCoef) \
    TOPVEC_IDX_LOOP_FORW_BEGIN(&(pPoly)->Coef,idx,EEMComplex,pCoef)
#define EEM_POLYCPLX_IDX_LOOP_FORW_END() \
    TOPVEC_LOOP_FORW_END()

#define EEM_POLYCPLX_IDX_LOOP_BACK_BEGIN(pPoly,idx,pCoef) \
    TOPVEC_IDX_LOOP_BACK_BEGIN(&(pPoly)->Coef,idx,EEMComplex,pCoef)
#define EEM_POLYCPLX_IDX_LOOP_BACK_END() \
    TOPVEC_LOOP_BACK_END()

typedef struct _EEMPolyCplxRat EEMPolyCplxRat;
struct _EEMPolyCplxRat {

    EEMPolyCplx                    Whole;
    EEMPolyCplx                    Numer;
    EEMPolyCplx                    Denom;
};

#if __TOP_DEBUG__
#define EEM_POLYCPLX_Print(pkg,pPoly,title) {	\
    if ( topMsgPkgDbgOnB(pkg) ) {		\
	eemPolyCplxPrint(pPoly,title);		\
    }						\
}

#define EEM_POLYCPLXRAT_Print(pkg,pPoly,title) {	\
    if ( topMsgPkgDbgOnB(pkg) ) {			\
	eemPolyCplxRatPrint(pPoly,title);		\
    }							\
}
#else
#define EEM_POLYCPLX_Print(pkg,pPoly,title) /* */
#define EEM_POLYCPLXRAT_Print(pkg,pPoly,title) /* */
#endif

#define EEM_CPOLY_SIZE	100	/* Array size for cpoly() */

/*
 * poly.c :: PolyCplx
 */
extern void		eemPolyCplxConstructor( EEMPolyCplx *pPoly);
extern void		eemPolyCplxDestructor( EEMPolyCplx *pPoly);
extern EEMPolyCplx*     eemPolyCplxCreate();	
extern void	        eemPolyCplxDestroy( EEMPolyCplx *pPoly);	
extern void		eemPolyCplxSetNum( EEMPolyCplx *pPoly, int N); 
extern void		eemPolyCplxInsureNum( EEMPolyCplx *pPoly, int N); 
extern EEMPolyCplx*	eemPolyCplxCopy( EEMPolyCplx *pPoly);
extern void		eemPolyCplxCopy2( EEMPolyCplx *pSrc, EEMPolyCplx *pDst);
extern void 		eemPolyCplxPrint(EEMPolyCplx *pPoly, char* title);
extern void		eemPolyCplxShorten(EEMPolyCplx *pPoly);
extern void		eemPolyCplxZero( EEMPolyCplx *pPoly, int N);
extern TOPLogical	eemPolyCplxZeroB( EEMPolyCplx *pPoly);
extern void		eemPolyCplxOne( EEMPolyCplx *pPoly);
extern TOPLogical	eemPolyCplxOneB( EEMPolyCplx *pPoly);

extern EEMPolyCplx*	eemPolyCplxAdd( EEMPolyCplx *pSrc1, EEMPolyCplx *pSrc2); 
extern void		eemPolyCplxAdd2(EEMPolyCplx *pDst, EEMPolyCplx *pSrc);
extern void		eemPolyCplxAdd3(EEMPolyCplx *pSrc1, EEMPolyCplx *pSrc2, 				EEMPolyCplx *pDst);	
extern void 		eemPolyCplxSub2(EEMPolyCplx *pDst, EEMPolyCplx *pSrc);
extern void		eemPolyCplxSub3(EEMPolyCplx *pSrc1, EEMPolyCplx *pSrc2, 				EEMPolyCplx *pDst);
extern void		eemPolyCplxMulConst2(EEMPolyCplx *pDst, double val);
extern void		eemPolyCplxMulConst3(EEMPolyCplx *pSrc, double val, 
				EEMPolyCplx *pDst);
extern void		eemPolyCplxMulConstCplx2(EEMPolyCplx *pDst, EEMComplex *pVal);
extern void		eemPolyCplxMulConstCplx3(EEMPolyCplx *pSrc, EEMComplex *pVal, EEMPolyCplx *pDst);

extern void		eemPolyCplxMul2(EEMPolyCplx *pD, EEMPolyCplx *pS);
extern void		eemPolyCplxMul3(EEMPolyCplx *pS1, EEMPolyCplx *pS2, EEMPolyCplx *pD);
extern void 		eemPolyCplxMulX(EEMPolyCplx *pPoly, int k);
extern void		eemPolyCplxDotVec3( EEMPolyCplx *pSrc, TOPVector *pVec, EEMPolyCplx *pDst);

extern void		eemPolyCplxToArrays( EEMPolyCplx *pPoly, double *pR, double *pI, int first);
extern void		eemPolyCplxPower2(EEMPolyCplx *pD, int power);
extern void		eemPolyCplxPower3(EEMPolyCplx *pS, int power,
			  EEMPolyCplx *pD);
extern void		eemPolyCplxEval(EEMPolyCplx *pPoly, EEMComplex *pVal, EEMComplex *pDst);
extern void		eemPolyCplxDiff1(EEMPolyCplx *pSD);

extern void		eemPolyCplxDiff2(EEMPolyCplx *pSrc, EEMPolyCplx *pDst);
extern void		eemPolyCplxZeroImag(EEMPolyCplx *pPoly);
extern void		eemPolyCplxReverse( EEMPolyCplx *pPoly);
extern void		eemPolyCplxRI2MP( EEMPolyCplx *pRI, EEMPolyCplx *pMP);



/*
 * poly.c :: PolyCplxRat
 */
extern void		eemPolyCplxRatConstructor( EEMPolyCplxRat *pRat);
extern void		eemPolyCplxRatDestructor( EEMPolyCplxRat *pRat);
extern void		eemPolyCplxRatDiff1(EEMPolyCplxRat *pDst);
extern void		eemPolyCplxRatDiff2(EEMPolyCplxRat *pSrc, EEMPolyCplxRat *pDst);
extern void		eemPolyCplxRatCopy(EEMPolyCplxRat *pD, EEMPolyCplxRat *pS);
extern void 		eemPolyCplxRatEval(EEMPolyCplxRat *pP, EEMComplex *pVal,
			      EEMComplex *pDst);
extern void 		eemPolyCplxRatNormDen(EEMPolyCplxRat *pDst);
extern void 		eemPolyCplxRatDiv(EEMPolyCplxRat *pPR);
extern void     	eemPolyCplxRatPrint(EEMPolyCplxRat *pRat, char *title);
extern void		eemPolyCplxRatProperize(EEMPolyCplxRat *pRat);


/*
 * polysilar.c :: Conversion between SilarGrp and PolyCplx
 */
extern void		eemSilarToPolyCplx( EEMSilar *pSilar, EEMPolyCplx *pD);
extern void		eemSilarGrpToPolyCplx(EEMSilarGrp *pSG,
			  EEMPolyCplx *pPoly, int sign);
extern void		eemSilarGrpToPolyCplxRat(EEMSilarGrp *pSG,
			  EEMPolyCplxRat *pRat);
extern TOPLogical	eemPolyCplxToSilarGrp( EEMPolyCplx *pPoly,
			  EEMComplex *pGain, EEMSilarGrp *pSG, int sign);
extern void		eemArraysToSilarGrp( double *rvec, double *ivec, int n,
			  EEMSilarGrp *pSG, int sign);

/*
 * polyTcl.c
 */
extern int	eemPolyCplxFmtTcl ARGS_TCL((Tcl_Interp *ip,
		  EEMPolyCplx *pPoly, TOPLogical NestB, char *fmtStr));
extern int	eemPolyCplxPrsTcl ARGS_TCL((Tcl_Interp *ip, 
		  EEMPolyCplx *pPoly, int aC, char **aV));
extern int	eemPolyCplxStrPrsTcl ARGS_TCL((Tcl_Interp *ip,
		  EEMPolyCplx *pPoly, char *polyStr));
extern int	eemPolyCplxRatFmtTcl ARGS_TCL((Tcl_Interp *ip,
		  EEMPolyCplxRat *pRat, TOPLogical NestB));
extern int	eemPolyCplxRatPrsTcl ARGS_TCL((Tcl_Interp *ip,
		  EEMPolyCplxRat *pRat, int aC, char **aV));
extern int	eemPolyCplxRatStrPrsTcl ARGS_TCL((Tcl_Interp *ip,
		  EEMPolyCplxRat *pRat, char *ratStr));
extern int	eemPolyCplxRegisterCmds ARGS_TCL((Tcl_Interp *ip));

#endif /* _EEMPOLY_H_ */
