/**
    jef.c

    Functions for dealing with elliptical filters and jocobian
    elliptical functions.
**/

#include "topFixup.h"
#include <stdio.h>
#include <math.h>
#include "tcl.h"

#include "topStd.h"

#include "eemCplx.h"
#include "eemSilar.h"
#include "eemJef.h"

main( int argc, char **argv) {
    Tcl_Interp		*ip;
    EEMSilarGrp		silarGrp;
    int			N;
    double		m, epsilon;
				
    if ( argc != 4 ) {
	printf("usage: %s N m epsilon\n", argv[0]);
	printf("using tcl interpreter...\n");

	ip = Tcl_CreateInterp();
	topMsgRegisterCmds(ip);
	eemEllipRegisterCmds(ip);
	topTclMainLoop(ip, "jef> ");
	exit(0);
    }
    
    N=atoi(argv[1]);
    m=atof(argv[2]);
    epsilon=atof(argv[3]);

    eemSilarGrpConstructor( &silarGrp);
    eemEllipFilter( &silarGrp, N, m, epsilon);
    eemSilarGrpPrint( &silarGrp, "elliptical filter");
    eemSilarGrpDestructor( &silarGrp);
    exit(0);
}
