#if !defined(_MEMCORE_H_)
#define _MEMCORE_H_ 1
/* 
    RCS: $Header: /vol/cooley/cooley1/kennard/src/top/RCS/memCore.h,v 1.2 93/08/27 14:28:41 kennard Exp $
    Author: Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/

struct _MEMPoolSeg {
    DLElem		chain;		/* must be first */
    TOPPtr		start;		/* start of allocation */
    TOPPtr		cur;		/* one past last allocated */
    TOPPtr		end;		/* one past end of segment */
};
#define MEM_POOLSEG_START(pSeg) ((pSeg)->start)


struct _MEMPool {
    DLElem		chainHead;
    int			poolsegSize;
};

struct _MEMPoolFree {
    MEMPoolFree		*next;
    int			magic;
};

#define MEM_POOL_MAGIC_ALLOC	(0)
#define MEM_POOL_MAGIC_FREE	(0xffff3d56)
#define MEM_POOL_MAGIC_WASTED	(0xffff3d59)

#define MEM_POOL_FREE_PUSH(ppListHead, ppOb) (			\
    ( (*(MEMPoolFree**)(ppOb))->next = (*(ppListHead)) ),	\
    ( (*(ppListHead)) = (*(MEMPoolFree**)(ppOb)) )		\
)

#define MEM_POOL_FREE_PUSH_F(ppListHead, ppOb, f) (		\
	( (*(MEMPoolFree**)(ppOb))->magic = (f) ),     		\
	MEM_POOL_FREE_PUSH((ppListHead), (ppOb))                \
)

#define MEM_POOL_FREE_POP(ppListHead, ppOb) (			\
    ( (*(MEMPoolFree**)(ppOb)) = (*(ppListHead)) ),		\
    ( (*(ppListHead)) = (*(ppListHead))->next ),		\
    ( (*(MEMPoolFree**)(ppOb))->next = NULL )			\
)

struct _MEMStack {
    DLElem		chain;		/* global chain of stacks */
    char		*name;
    MEMPool		pool;
    int			totAllocs;
    int			totAllocBytes;
    int			totFrees;
    int			totFreeBytes;
};

struct _MEMSuperHeap {
    DLElem		chain;		/* global chain of super heaps */
    DLElem		headHeapChain;	/* chain of heaps attach to this one */
    char		*name;
    int			objectSize;
    MEMPool		pool;
    MEMPoolFree		*freelist;
    int			totAllocs;
    int			totCrams;
    int			totFrees;
};

#define MEM_SUPERHEAP_MINSIZE 8		/* must be > sizeof(MEMPoolFree) */

struct _MEMHeap {
    DLElem		chain;		/* of heaps in super heap */
    char		*name;
    MEMSuperHeap	*super;
    int			numAllocs;
    int			numFrees;
};

/* typedef is in mem.h */
struct _MEMCore {
    DLElem		headPoolSegSegs;
    MEMSuperHeap	rootPoolSegs;
    int			numStacks;
    DLElem		headStacks;
    MEMSuperHeap	rootStacks;
    int			numSuperHeaps;
    DLElem		headSuperHeaps;
    MEMSuperHeap	rootSuperHeaps;
    int			numHeaps;
    MEMSuperHeap	rootHeaps;
    MEMSuperHeap	**publicSuperHeaps;
    int			publicSuperHeapNumLinear;
    int			publicSuperHeapNumTotal;
    int			numDupFreeReal;
    int			numDupFreeFake;
    int			numBadFree;
    int			bytesMalloc;
    int			bytesFree;
};


/* memCore.c */
extern MEMCore		 _MemCore;
extern TOPLogical	 _MemInitedB;
#define MEM_ASSERT_INITED()	( _MemInitedB ? 0 : (_memAssertInited(), 0) )
extern void		_memAssertInited();

/* memPool.c */
extern MEMPoolSeg*	_memPoolSegAlloc( MEMPool *pPool, int allocSize);
#endif /* _MEMCORE_H_ */
