/* 
    toptcl.c

    Author: Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/
#if !defined(lint) && !defined(SABER)
static char rcsid[] = "$Header: /vol/cooley/cooley1/kennard/src/top/RCS/tclRet.c,v 1.2 93/08/27 14:29:05 kennard Exp $";
#endif

#include "topFixup.h"
#include <stdarg.h>
#include <tcl.h>
#include "topStd.h"
#include "topTcl.h"

void topTclRet( Tcl_Interp *ip, char *msg) {
    Tcl_Return( ip, msg, TCL_VOLATILE);
}

void topTclRetVa( Tcl_Interp *ip, char *fmt, va_list args) {
    char buf[1000];

    vsprintf( buf, fmt, args);
    topTclRet( ip, buf);
}

void topTclRetFmt( Tcl_Interp *ip, char *fmt, ...) {
    va_list args;

    va_start( args, fmt);
    topTclRetVa( ip, fmt, args);
    va_end( args);
}

int topTclErr( Tcl_Interp *ip, char *err) {
    Tcl_Return( ip, err, TCL_VOLATILE);
    return TCL_ERROR;
}

int topTclErrVa( Tcl_Interp *ip, char *fmt, va_list args) {
    char buf[1000];

    vsprintf( buf, fmt, args);
    return topTclErr( ip, buf);
}

int topTclErrFmt( Tcl_Interp *ip, char *fmt, ...) {
    int ret;
    va_list args;

    va_start( args, fmt);
    ret = topTclErrVa( ip, fmt, args);
    va_end( args);
    return ret;
}

void topTclAppendResult( Tcl_Interp *ip, char *msg) {
    Tcl_AppendResult( ip, msg, NULL);
}

void topTclAppendResultVa( Tcl_Interp *ip, char *fmt, va_list args) {
    char buf[1000];

    vsprintf( buf, fmt, args);
    topTclAppendResult( ip, buf);
}

void topTclAppendResultFmt( Tcl_Interp *ip, char *fmt, ...) {
    va_list args;

    va_start( args, fmt);
    topTclAppendResultVa( ip, fmt, args);
    va_end( args);
}
