# sepexpr angle .2
# sepexpr mag .8
proc create4 { filter } {
    sepcomplex poleR mp mag { angle + 0 }
    sepcomplex poleT mp mag { angle + PI/2 }
    sepcomplex poleL mp mag { angle + PI }
    sepcomplex poleB mp mag { angle - PI/2 }
    $filter silar create poleR pole
    $filter silar move poleR poleR
    $filter silar create poleT pole
    $filter silar move poleT poleT
    $filter silar create poleL pole
    $filter silar move poleL poleL
    $filter silar create poleB pole
    $filter silar move poleB poleB
}


proc c4a { filter } {
    sepcomplex $filter.poleR mp mag { angle + 0 }
    sepcomplex $filter.poleT mp mag { angle + PI/2 }
    sepcomplex $filter.poleL mp mag { angle + PI }
    sepcomplex $filter.poleB mp mag { angle - PI/2 }
    $filter silar create $filter.poleR pole @
    $filter silar create $filter.poleT pole @
    $filter silar create $filter.poleL pole @
    $filter silar create $filter.poleB pole @
}


proc c4b { filter } {
    sepcomplex $filter.poleR mp { 1 / mag } { angle + 0 }
    sepcomplex $filter.poleT mp { 1 / mag } { angle + PI/2 }
    sepcomplex $filter.poleL mp { 1 / mag } { angle + PI }
    sepcomplex $filter.poleB mp { 1 / mag } { angle - PI/2 }
    $filter silar create $filter.poleR pole @
    $filter silar create $filter.poleT pole @
    $filter silar create $filter.poleL pole @
    $filter silar create $filter.poleB pole @
}

proc cpair { filter } {
    set m $filter.master
    $filter silar create $m pole { .5 .5 } export conj
    sepexpr $filter.slave { - $m }
    $filter silar create $filter.slave zero @ conj
}

proc exp { port } {
    ipc connect qdm halley $port
    H1 export qdm
}

proc testImpulse { filter } {
    $filter traj trajA ind-hoo ind-goo { { viv CplxSeqImpulse } } {
	{ 0.0 info { viv {5 0} } }
	{ 1.0 info { viv {2 2} {3 2} {2 4} {5 1} } }
	{ 2.0 info { viv {3 4} {4 1} {5 3} {3 2} } }
	{ 3.0 info { viv 4 5 6 7 } }
	{ 4.0 info { viv 5 6 7 8 } }
	{ 5.0 info { viv 5 4 3 2 } }
    }
}
proc addTraj { filter } {
    ${filter}.trajA appendSnap  \
      { 6.0 info { viv 4 3 3 2.5 } } \
      { 7.0 info { viv 3 3 4 4 } }
}

proc showTraj { filter } {
    bdg create $filter { { impulse trajA.viv.mag } }
}

proc setup2 { } {
    filter create H2
    testImpulse H2
    showTraj H2
}

proc ib { filter traj data } {
    bdg impulse $filter.$traj.$data
    bdg freq    $filter.$traj.$data/ImpulseFourier
    bdg plane   $filter.$traj.$data/ImpulseSilar
    bdg freq    $filter.$traj.$data/ImpulseSilar/SilarFourier
}

proc defTrajB { filter } {
    $filter traj trajB ind-hoo ind-goo { { qqq SilarRep } } {
	{ 1.0 info { qqq { 1 0 } { p0 pole {  .5  .5 } 1 } } }
	{ 2.0 info { qqq { 1 0 } { p0 pole { -.5  .5 } 1 } } }
	{ 3.0 info { qqq { 1 0 } { p0 pole { -.5 -.5 } 1 } } }
	{ 4.0 info { qqq { 1 0 } { p0 pole {  .5 -.5 } 1 } } }
    }
}

proc showTrajB { filter } {
    bdg create $filter { { plane trajB.qqq } { freq trajB.silFT } }
}


proc defTrajC { filter } {
    $filter traj trajC ind-hoo ind-goo { { impulse CplxSeq } } {
	{ 1.0 info { impulse 2 3 4 5 } }
	{ 2.0 info { impulse 3 4 5 6 } }
	{ 3.0 info { impulse 4 5 6 7 } }
	{ 4.0 info { impulse 5 6 7 8 } }
	{ 5.0 info { impulse 5 4 3 2 } }
    }
}

proc showTrajC { filter } {
    bdg create $filter { { freq trajC.impulse } { plane trajC.impSil } }
}

