puts stdout "Welcome to XPole.  Initializing..."
set PI 3.14159265358979323846

helplib xpole [file dirname [info script]]/xpole.hlp
xpsource filters.tcl
xpsource test.tcl
xpsource demo.tcl

proc defaultStartup { } {
#    puts stdout "Default startup code goes here"
    filter create H1(z)
    defaultTrajEdit default
    puts stdout "...Done.  XPole ready."
}

proc defaultTrajEdit { traj } {
    bdg plane $traj.stdSilar
    bdg siltbl $traj.stdSilar
    bdg fourier $traj.stdSilar/SilarFourier
}

proc clearFilterSilar { fltr } {
    $fltr trajcmd default dataset stdSilar clear
}

#
# info will have the form: { 0=baseName 1=domain 2=fName 3=existB }
#
proc _xpFltrSelCreate { dlgName action } {
    set names [$dlgName names]
    if { [string compare $names ""]==0 } then {
	set names [filter autoname]
    }
    set infolist [filter info $names]
    foreach info [lindex $infolist 0] {
	set fltrBaseName	[lindex $info 0] 
	set fltrDomain		[lindex $info 1] 
	set fltrFullName	[lindex $info 2] 
	set fltrNotExistB	[string compare [lindex $info 3] exist]
	if { ! $fltrNotExistB } then {
	    error [format "Filter %s already exists" $fltrFullName]
	}
	case $action in {
	    s-filter {
	    	filter create $fltrFullName s
		defaultTrajEdit $fltrBaseName.default
		$dlgName clear
	    }
	    z-filter {
	    	filter create $fltrFullName z
		defaultTrajEdit $fltrBaseName.default
		$dlgName clear
	    }
	    std-filter {
		stdfltrdlg $fltrBaseName
		$dlgName clear
	    }
	    default {
		error [format "Unknown action %s" $action]
	    }
	}
    }
}

proc _xpFltrSelInvoke { dlgName action } {
    case $action in {
	cancel {
	    $dlgName popdown
	    return
	}
	help {
	    help filterSelection
	    return
	}
    }
    set infolist [filter info [$dlgName names]]
    puts stdout [format "infolist is %s\n" $infolist]
    foreach info [lindex $infolist 0] {
        puts stdout [format "info is %s\n" $info]
	set fltrBaseName	[lindex $info 0] 
	set fltrDomain		[lindex $info 1] 
	set fltrFullName	[lindex $info 2] 
	set fltrNotExistB	[string compare [lindex $info 3] exist]
	case $action in {
	    delete {
		$fltrBaseName destroy
		$dlgName clear
	    }
	    edit {
		puts stdout [format "fltrBaseName is %s\n" $fltrBaseName]
		defaultTrajEdit $fltrBaseName.default
		$dlgName clear
	    }
	    default {
		error [format "Unknown action %s\n" $action]
	    }
	}
    }
}

