#
# viewsel.tcl :: Filter View Selector Dialogs :: XPole
#
#

proc viewsel.tcl { } { }

###############################################################################
#
#	 View Selection Dialog (VSD)
#
###############################################################################

#proc _xpVSD.Msg { dlg msg } {
#    upvar #0 $dlg dvars 
#    set dvars(msg) $msg
#    $dlg.msg conf -text $msg 
#}
#
#proc _xpVSD.ErrMsg { dlg msg } {
#    upvar #0 $dlg dvars 
#    $dlg.msg conf -text $msg 
#}
#
#proc _xpVSD.ResetMsg { dlg } {
#    upvar #0 $dlg dvars 
#    $dlg.msg conf -text $dvars(msg)
#}

proc _xpVSD.UpdateListbox { lb newitems oldselitems } {
    set selfrom -1; set selto -1
    foreach item $newitems {
	if { [set oldidx [lsearch $oldselitems $item]] != -1 } {
	    if { $selfrom==-1 } {
		set selfrom [$lb size]
	    }
	    set selto [$lb size]
	}
	$lb insert end $item
    }
    if { $selfrom == -1 } {
	$lb select from 0
    } else {
	$lb select from $selfrom 
	$lb select to $selto 
    }
}

proc _xpVSD.UpdateFltrListbox { dlg } {
    set list $dlg.m.fltr.box
    set oldsel [$list cursel]
    set oldselnames ""
    foreach os $oldsel { lappend oldselnames [$list get $os] }

    $list delete 0 end
    set items "" 
    foreach fltrinfo [filter fltrlist] { lappend items [lindex $fltrinfo 2] }
    _xpVSD.UpdateListbox $list $items $oldselnames
}

proc _xpVSD.UpdateViewListbox { dlg fltr }  {
    upvar #0 $dlg dvars 
    set list $dlg.m.view.box
    set oldsel [$list cursel]
    set oldselnames ""
    foreach os $oldsel { lappend oldselnames [$list get $os] }

    $list delete 0 end
    $list insert 0 "*All*"

    set items ""
#    puts stdout "fillview: ``$dvars(viewlb-fltr)'' vs ``$fltr''"
    if { [string length $fltr]>0 } {
        if { "$dvars(viewlb-fltr)"!="$fltr" } {
	    set oldselnames ""
	}
	foreach viewinfo [filter views $fltr] {
	    lappend items [lindex $viewinfo 1]
	}
    }
    _xpVSD.UpdateListbox $list $items $oldselnames
    set dvars(viewlb-fltr) $fltr
}


proc _xpVSD.UpdateText { dlg } {
    upvar #0 $dlg dvars 

    set text ""
    set fltridxs [$dlg.m.fltr.box cursel]
    foreach fltridx $fltridxs {
	set fltr [$dlg.m.fltr.box get $fltridx]
	set viewidxs [$dlg.m.view.box cursel]
	set allB [expr { [llength $viewidxs]==0 || [lsearch $viewidxs 0]!=-1 } ]
	if { $allB } {
	    lappend text $fltr
	} else {
	    foreach viewidx $viewidxs {
		set viewname [$dlg.m.view.box get $viewidx]
		lappend text $fltr.$viewname
	    }
	}
    }
    topEntry.set $dlg.text.entry $text

    set iw $dlg.m.info.box
    $iw delete 1.0 end
    case [llength $fltridxs] {
      0 {
	$iw insert 1.0 "Select a filter or view and information about it will appear here."
      }
      1 {
	if { $allB } {
	    set li [xpFltr.LongInfo $fltr]
	    $iw insert 1.0 $li
	} else {
	    if { [llength $viewidxs]==1 } {
		set li [xpView.LongInfo $fltr.$viewname]
		$iw insert 1.0 $li
	    } else {
		$iw insert 1.0 "<Multiple views>"
	    }
	}
      }
      default {
	$iw insert 1.0 "<Multiple filters>"
      }
    }
}

proc _xpVSD.UpdateViews { dlg } {
    set fltrsel [$dlg.m.fltr.box cursel]
    set fltrname [expr { [llength $fltrsel] == 1 \
      ? [$dlg.m.fltr.box get $fltrsel] : "" } ]
    _xpVSD.UpdateViewListbox $dlg $fltrname
    _xpVSD.UpdateText $dlg
}

proc _xpVSD.UpdateFltrs { dlg } {
    _xpVSD.UpdateFltrListbox $dlg
    _xpVSD.UpdateViews $dlg
}

proc _xpVSD.TraceFilters { dlg n1 n2 op } {
#    puts stdout "_xpVSD.TraceFilters"
    _xpVSD.UpdateFltrs $dlg
}

proc _xpVSD.FLB_B1 { dlg mode y } {
    set idx [$dlg.m.fltr.box nearest $y]
    $dlg.m.fltr.box select $mode $idx
    _xpVSD.UpdateViews $dlg
}

proc _xpVSD.VLB_B1 { dlg y } {
    set idx [$dlg.m.view.box nearest $y]
    $dlg.m.view.box select from $idx
    _xpVSD.UpdateText $dlg
}

proc _xpVSD.VLB_B1_Motion { dlg y } {
    set idx [$dlg.m.view.box nearest $y]
    $dlg.m.view.box select to $idx
    _xpVSD.UpdateText $dlg
}

proc _xpVSD.GetSpecs { dlg } {
    set speclist ""
    foreach spec [$dlg.text.entry get] {
	set idx [string first . $spec]
	if { $idx==-1 } {
	    lappend speclist [list $spec $spec ""]
	} else {
	    set fltr [string range $spec 0 [expr $idx-1]]
	    set view [string range $spec [expr $idx+1] end]
	    lappend speclist [list $spec $fltr $view]
	}
    }
    return $speclist
}


# tvc = target view class
proc _xpVSD.DisplayView { dlg tvc } {
    upvar #0 $dlg dvars

    foreach spec [_xpVSD.GetSpecs $dlg] {
	set fltr [lindex $spec 1]
	set viewname [lindex $spec 2]
	# Create the filter incase it doesnt exist yet
	filter get $fltr
	set fltrinfo [filter info $fltr]
	set fltrname [lindex $fltrinfo 0]
	if { "[lindex $fltrinfo 3]"!="exist" } {
	    xpStd.DlgErr $dlg-msg "DisplayView" \
	      "Filter $fltrname doesn't exist"
	    return
	}
	if { "$viewname"=="" } {
	    set viewinfo [xpView.GetByClass $fltrname $tvc]
	    if { "$viewinfo"=="" } {
		xpStd.DlgErr $dlg-msg "DisplayView" \
		  "Can't get $tvc view in $fltrname"
		return
	    }
	    xpView.Display $fltrname.[lindex $viewinfo 1]
	} else {
	    set viewinfo [view get $fltrname.$viewname]
	    set viewclass [lindex $viewinfo 2]
	    if { "$viewclass"!="$tvc" } {
		set viewinfo [xpView.GetByPipe $fltrname \
		  $viewname $viewclass "" $tvc]
		if { "$viewinfo"=="" } {
		    xpStd.DlgErr $dlg-msg "DisplayView" \
		      "Can't create $tvc view from $fltrname.$viewname"
		    return
		}
	    }
	    xpView.Display $fltrname.[lindex $viewinfo 1]
	}
    }
    focus none
}

proc _xpVSD.Display { dlg } {
    upvar #0 $dlg dvars 

    foreach spec [_xpVSD.GetSpecs $dlg] {
	set fltr [lindex $spec 1]
	set view [lindex $spec 2]
	if { "$view"=="" } {
	    xpFltr.Display $fltr
	} else {
	    xpView.Display $fltr.$view
	}
    }
    focus none
}

proc _xpVSD.Delete { dlg } {
    upvar #0 $dlg dvars 

    foreach spec [_xpVSD.GetSpecs $dlg] {
	set fltr [lindex $spec 1]
	set view [lindex $spec 2]
	if { "$view"=="" } {
	    xpFltr.Destroy $fltr
	} else {
	    xpView.Destroy $fltr.$view
	}
    }
    focus none
}

proc _xpVSD.Popdown { dlg } {
    upvar #0 $dlg dvars 

    trace vdel xpole(filters) w "_xpVSD.TraceFilters $dlg"
    unset dvars
    destroy $dlg
}

proc _xpVSD.Ok { dlg ok_command } {
    set specs [_xpVSD.GetSpecs $dlg]
    if { [llength $specs]!=1 } {
	xpStd.DlgErr $dlg-msg "Fltr/View Ok" \
	  "Must specify exactly one filter"
	return
    }
    _xpVSD.Popdown $dlg
    set spec [lindex $specs 0]
#puts stdout "_xpVSD.Ok ``$spec''"
    filter get [lindex $spec 1]
    eval $ok_command [lindex $spec 0]
}

proc xpVSD.Make { dlg title ok_command } {
    global xpole

    menu $dlg.topbar.title.m

    upvar #0 $dlg dvars 
    set dvars(fltr) ""
    set dvars(fltridx) "-1"
    set dvars(viewlb-fltr) ""

#    pack append $dlg [label $dlg.title -text $title] { top fillx }

    xpStd.DlgErrCreate $dlg-msg $dlg.msg "Select a filter"
#    button $dlg.msg -relief flat -anchor w -text "" -com "_xpVSD.ResetMsg $dlg"
#    pack append $dlg $dlg.msg { top fillx }
#    set dvars(msg) "Select a filter"
#    $dlg.msg invoke

    pack append $dlg [frame $dlg.m -bd 3] {top fill expand}

    set dd $dlg.m.fltr
    pack append $dlg.m [frame $dd] {left fill}
    pack append $dd [label $dd.title -text "Filter:"] {top}
    pack append $dd [listbox $dd.box -relief sunken -export no] {top fill}
    bind $dd.box <1> "_xpVSD.FLB_B1 $dlg from %y"
    bind $dd.box <B1-Motion> "_xpVSD.FLB_B1 $dlg to %y"

    pack append $dlg.m [frame $dlg.m.sep1 -width 3 -height 1] {left fill}

    set dd $dlg.m.view
    pack append $dlg.m [frame $dd] {left fill}
    pack append $dd [label $dd.title -text "View:"] {top}
    pack append $dd [listbox $dd.box -relief sunken -export no] {top fill}
    bind $dd.box <1> "_xpVSD.VLB_B1 $dlg %y"
    bind $dd.box <B1-Motion> "_xpVSD.VLB_B1_Motion $dlg %y"

    pack append $dlg.m [frame $dlg.m.sep2 -width 3 -height 1] {left fill}

    set dd $dlg.m.info
    pack append $dlg.m [frame $dd] {left expand fill}
    pack append $dd [label $dd.title -text "Description:"] {top}
    pack append $dd [text $dd.box -height 10 -width 30 -wrap word] {top fill}

    set dd $dlg.text
    frame $dd -bd 2; pack append $dlg $dd { top fillx }
    pack append $dd [label $dd.lbl -text "Fltr View:"] { left }
    pack append $dd [entry $dd.entry -relief sunken] { left expand fill }

    set dd $dlg.editbuts
    frame $dd -bd 2; pack append $dlg $dd { top fillx }
    button $dd.edit -text "Display" -com "_xpVSD.Display $dlg"
    pack append $dd $dd.edit { left fillx expand }
    foreach p { {SilarRep PoleZero} \
      {CplxSeqFreq Fourier} {CplxSeqTime Impulse} } {
	set p0 [lindex $p 0]
	set p1 [lindex $p 1]
        pack append $dd [button $dd.[string tolower $p0] -text "Display $p1" \
	  -com "_xpVSD.DisplayView $dlg $p0"] { left fillx expand }
    }

    set dd $dlg.buts
    frame $dd -bd 2; pack append $dlg $dd { top fillx }
    if { "$ok_command"!="" } {
        pack append $dd [button $dd.ok -text "Ok" \
	  -com "_xpVSD.Ok $dlg { $ok_command } "] { left fillx expand }
    }
    pack append $dd [button $dd.delete -text "Delete" \
      -com "_xpVSD.Delete $dlg"] { left fillx expand }
    $dd.delete conf -state disabled
    pack append $dd [button $dd.cancel -text "Cancel" \
      -com "_xpVSD.Popdown $dlg"] { left fillx expand }

    _xpVSD.UpdateFltrs $dlg
    trace var xpole(filters) w "_xpVSD.TraceFilters $dlg"
}

proc xpViewSelDlg { {title "Fltr/View Dialog"} {ok_command ""} } {
    set dlg [xpStdDlgPopup .viewsel[topGenSN] "ViewSel" $title \
      "(xpole)ViewSelDlg"]
    xpVSD.Make $dlg $title $ok_command
}

###############################################################################
#
#	 Filter functions (no UI)
#
###############################################################################

proc xpFltr.Destroy { fltr } {
    filter destroy $fltr
}

proc xpFltr.Display { fltr } {
    
}

proc xpFltr.LongInfo { fltrspec } {
    set fltrinfo [filter info $fltrspec]
    append li "Filter:\t[lindex $fltrinfo 0]([lindex $fltrinfo 1])\n"
    set desc [filter description $fltrspec]
    if { "$desc"!="" } {
	append li "Description: $desc\n"
    }
    return $li
}

###############################################################################
#
#	 Filter "view" functions (no UI)
#
###############################################################################

proc xpView.SanitizeName { viewspec } {
}

#
# Get the target view {tvn} of class {tvc} derived from by pipe from
# the source view {svn} of class {svc}.  The type of pipe to use
# is determined by the src & tgt classes.  {tvn} may be "", in which
# case a reasonable name is auto-generated.
# Returns a viewinfo list or "".
# Note: s=src, t=tgt, v=view, c=class, n=name
#
proc xpView.GetByPipe { fltrname svn svc tvn tvc } {
    case $svc {
      SilarRep {
	case $tvc {
	  {CplxSeqFreq CplxSeqFourier} {
	    if { "$tvn"=="" } { set tvn $svn-fourier }
	    return [view get $fltrname.$tvn=PolezeroFourier/$fltrname.$svn]
	  }
	  {CplxSeqTime CplxSeqImpulse} {
	    if { "$tvn"=="" } { set tvn $svn-impulse }
	    return [view get $fltrname.$tvn=PolezeroImpulse/$fltrname.$svn]
	  }
	}
      }
      CplxSeqTime {
	case $tvc {
	  {CplxSeqFreq CplxSeqFourier} {
	    if { "$tvn"=="" } { set tvn $svn-fourier }
	    return [view get $fltrname.$tvn=ImpulseFourier/$fltrname.$svn]
	  }
	}
      }
    }
    return ""
}

proc xpView.FindByClass { fltrname tvc } {
    foreach viewinfo [filter views $fltrname] {
	if { "[lindex $viewinfo 2]"=="$tvc" } {
	    return $viewinfo
	}
    }
    return ""
}

#
# {fltrview} may be either a fltrname or a viewspec.
# If fltrname, a view of class {tvc} will be created and returned.
# If viewspec, it specifies a *source* viewspec.  If required, a
# pipe will be created to obtain the proper class.
#
proc xpView.GetByClass { fltrview tvc } {
    set idx [string first . $fltrview]
    if { $idx == -1 } {
        set viewinfo [xpView.FindByClass $fltrview $tvc]
        if { "$viewinfo"!="" } { return $viewinfo }
	# This code below is not right!  But it works for now.
	case $tvc {
	  SilarRep {
	    return [view get $fltrview.polezero SilarRep]
	  }
	  {CplxSeqFreq CplxSeqTime} {
	    set srcviewinfo [xpView.GetByClass $fltrview SilarRep]
	    set srcviewname [lindex $srcviewinfo 1] 
	    return [xpView.GetByPipe $fltrview $srcviewname SilarRep "" $tvc]
	  }
	}
	error "Don't know class ``$tvc''"
    }
    # We have a viewspec.  Get it (may either already exist, or
    # the spec may contain a pipespec).
    set viewinfo ""
    if [catch {view get $fltrview} viewinfo] {
	# Nope, no such view.  Just make it brand-new from the class.
	return [view get $fltrview $tvc]
    }
    if { "[lindex $viewinfo 2]"!="$tvc" } {
	# get pipe: fltr srcname srcclass tgtname tgtclass
	set viewinfo [xpView.GetByPipe [lindex $viewinfo 0] \
	  [lindex $viewinfo 1] [lindex $viewinfo 2] "" $tvc]
    }
    return $viewinfo
}

#
# If {insureOnlyB} is true and the view is already displayed then
# nothing will happen.
# Returns name of graph window.
#
proc xpView.Display { viewspec {insureOnlyB 0} } {
    set viewinfo [view get $viewspec]
    set viewfltr [lindex $viewinfo 0]
    set viewname [lindex $viewinfo 1]
    set viewspec $viewfltr.$viewname
    set suf [topWin.GenName .$viewfltr-$viewname]
    if { "[lindex $suf 1]"!="" && $insureOnlyB } {
	return [lindex $suf 2]
    }
    set w [lindex $suf 0]
    set wintitle "$viewfltr.$viewname [lindex $suf 1]"

    set class [lindex $viewinfo 2]
#puts stdout "xpView.Display: $w"
    case $class {
	SilarRep {
    	    topWin.GetTopLevel $w -class XPPlaneGraph
	    xpSilarPlaneGraph $w
	    xpSPG.InsSilarSet $w $viewspec
	}
	CplxSeqFreq {
    	    topWin.GetTopLevel $w -class XPSeqGraph
	    xpCplxSeqGraph $w Freq
	    xpCSG.InsSeq $w $viewspec
	}
	CplxSeqTime {
    	    topWin.GetTopLevel $w -class XPSeqGraph
	    xpCplxSeqGraph $w Time
	    xpCSG.InsSeq $w $viewspec
	}
    }
    wm title $w "XPole $wintitle"
    wm iconname $w $wintitle
    wm geometry $w 400x400
    wm minsize $w 10 10
    return $w
}

proc xpView.DisplayByClass { fltrview class {insureOnlyB 0} } {
   set viewinfo [xpView.GetByClass $fltrview $class]
#puts stdout "xpView.DisplayByClass: ``$fltrview'' ``$class'' $viewinfo"
   set viewspec [lindex $viewinfo 0].[lindex $viewinfo 1]
   return [xpView.Display $viewspec $insureOnlyB]
}

proc xpView.Destroy { viewspec } {
    view destroy $viewspec
}

proc xpView.LongInfo { viewspec } {
    set viewinfo [view info $viewspec]
    append li "View:\t[lindex $viewinfo 0]([lindex $viewinfo 4]).[lindex $viewinfo 1]\n\tClass [lindex $viewinfo 2]\n"
    set desc [view description $viewspec]
    if { "$desc"!="" } {
	append li "Description: $desc\n"
    }
    set master [view master $viewspec]
    if { "$master"!="" } {
	append li "Master:\t[lindex $master 0]\n\tClass [lindex $master 1]\n"
    }
    return $li
}
