#if !defined(_POLE_H_)
#define _POLE_H_ 1
/* 
    RCS: $Header: /vol/cooley/cooley1/kennard/src/xpole/RCS/pole.h,v 1.5 93/08/27 14:28:03 kennard Exp $
    pole.h :: XPole

    Non-X dependent decls for for XPole.

    Author: Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/

#include "eemCplx.h"
#include "topMem.h"
#include "topDlList.h"
#include "topVec.h"
#if defined(_TCL)
#include "topTcl.h"
#endif

typedef double XPFlt;

typedef struct _XPLabel XPLabel;
struct _XPLabel {
    TOPPtr		Me;
    int			SN;
    char*		Tag;
    char*		Name;
    char*		Class;
};

typedef struct _XPMachine XPMachine;
struct _XPMachine {
    TOPMask		ChangeMask;	/* logical OR of call filters */
    struct Tcl_Interp*	ip;
    DLListHandle	FltrList;	/* of XPFilter */
    DLPtrListHandle	AgentList;	/* of XPAgent* */
    DLPtrListHandle	PipeList;	/* of XPPipe* */

    /* TOPLogical	ServerFixB; */
    /* extern int XPErrorMode; */
    /* extern int XPForceBW; */
    /* DLList*		FltrBdgList; */
    TOPLogical		RunEventsB;
};
extern XPMachine XPTheMachine;
extern char XpVersionString[];
extern char XpCopyrightString[];

/*
 * Masks for XPMachine.ChangeMask
 */
#define XP_CHNG_FLTR_SILAR	TOP_BIT(11)
#define XP_CHNG_FLTR_EXIST	TOP_BIT(12)
#define XP_CHNG_GLOB_CALL	TOP_BIT(13)


#ifdef notdef
extern void xpTty( char *msg);
extern void xpTclCmd( char *cmd);
extern void xpTtyVa ARGS_VA(( char *fmt, va_list args));
extern void xpTclCmdVa ARGS_VA(( char *fmt, va_list args));
extern void xpTtyFmt( char *fmt, ...);
extern void xpTclCmdFmt( char *fmt, ...);
#endif

/*
 * tkpole.c
 */
extern void	xpLabelConstructor ARGS((XPLabel *pLbl,
		  TOPPtr pMe, int *pSN, char *name, char *class));
extern void	xpLabelDestructor ARGS((XPLabel *pLbl));

 /*
  * poleTcl.c
  */
extern void	xpLabelFmtTcl ARGS_TCL((Tcl_Interp *ip,
		  XPLabel *pLbl, TOPLogical nestB));

extern void xpPoleRegisterCmds ARGS_TCL((Tcl_Interp *ip));
#endif /* _POLE_H_ */
