/* 
    Author: Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/
#if !defined(lint) && !defined(SABER)
static char rcsid[] = "$Header: /vol/cooley/cooley1/kennard/src/xpole/RCS/poleTcl.c,v 1.5 93/08/27 14:28:16 kennard Exp $";
#endif

#include "topFixup.h"
#include <tcl.h>
#if defined(XPOLE_TCP)
#include "tclTCP.h"
#endif

#include "topStd.h"
#include "topTcl.h"
#include "eemPoly.h"
#include "eemJef.h"

#include "pole.h"
#include "filter.h"
#include "silar.h"
#include "cplxseq.h"
#include "pipe.h"

void
xpLabelFmtTcl( Tcl_Interp *ip, XPLabel *pLbl, TOPLogical nestB) {
    if ( nestB )	Tcl_AppendResult(ip," {",NULL);
    Tcl_AppendResult(ip," ",pLbl->Name," ",pLbl->Class," ",pLbl->Tag,
      " ",NULL);
    if ( nestB )	Tcl_AppendResult(ip,"}",NULL);
}

void
xpSetDefXfDomain( XPXformDomain dom) {
    XPMachine		*pMach = &XPTheMachine;
    Tcl_Interp		*ip = pMach->ip;
    char		buf[20];

    buf[0] = dom;
    buf[1] = '\0';
    Tcl_SetVar2( ip, "xpole", "xfdomain", buf, TCL_GLOBAL_ONLY);
}

XPXformDomain
xpGetDefXfDomain() {
    XPMachine		*pMach = &XPTheMachine;
    Tcl_Interp		*ip = pMach->ip;
    char		*val;

    val = Tcl_GetVar2( ip, "xpole", "xfdomain", TCL_GLOBAL_ONLY);
    if ( val == NULL ) {
	xpSetDefXfDomain( XP_XFDOM_Z);
	return XP_XFDOM_Z;
    }
    return *val;
}

static int
_xpPoleCmd( ClientData cld, Tcl_Interp *ip, int aC, char **aV) {
    XPMachine		*pMach = (XPMachine*) cld;
    char		c, *cmd;
    int			len;

    if (aC < 2) {
	Tcl_AppendResult(ip,"usage: ",aV[0],
	  " destroy|quit|author|version|copyright ...", NULL);
	return TCL_ERROR;
    }
    cmd = aV[1]; c = *cmd; len = strlen(cmd);
    /*IF*/ if ( (c=='d' && strncmp(cmd,"destroy",len)==0)
             || (c=='q' && strncmp(cmd,"quit",len)==0) ) {
	xpDestroy( pMach);
    } else if ( c=='a' && strncmp(cmd,"author",len)==0 ) {
	Tcl_SetResult( ip, "Kennard White", TCL_STATIC);
    } else if ( c=='v' && strncmp(cmd,"version",len)==0 ) {
	Tcl_SetResult( ip, XpVersionString, TCL_STATIC);
    } else if ( c=='c' && strncmp(cmd,"copyright",len)==0 ) {
	Tcl_SetResult( ip, XpCopyrightString, TCL_STATIC);
    } else {
	Tcl_AppendResult(ip,aV[0],": bad command: ",aV[1], NULL);
	return TCL_ERROR;
    }
    return TCL_OK;
}

void xpPoleRegisterCmds( Tcl_Interp *ip) {
    eemEllipRegisterCmds( ip);
    eemPolyCplxRegisterCmds( ip);

    Tcl_CreateCommand( ip, "xpole", _xpPoleCmd, 
      (ClientData)&XPTheMachine, NULL);
    Tcl_CreateCommand( ip, "filter", _xpFilterCmd, 
      (ClientData)&XPTheMachine, NULL);
    Tcl_CreateCommand( ip, ".", _xpFltrDotCmd, NULL, NULL);
    Tcl_CreateCommand( ip, "view", _xpViewCmd, 
      (ClientData)&XPTheMachine, NULL);
    Tcl_CreateCommand( ip, "agent", _xpAgentCmd, 
      (ClientData)&XPTheMachine, NULL);
#ifdef notdef
    Tcl_CreateCommand( ip, "bdg",  _xpFltrShellBdgCmd, 
      (ClientData)&XPState, NULL);
    Tcl_CreateCommand( ip, "bdgs", _xpFltrShellBdgsCmd, 
      (ClientData)&XPState, NULL);
    Tcl_CreateCommand( ip, "ipc", ipc, NULL, NULL);
#endif


    xpFltrRepRegisterCmds( ip);
    xpPipeRegisterCmds( ip);
    xpSilarDhRegisterCmds( ip);
    xpCplxSeqDhRegisterCmds( ip);

#if defined(XPOLE_TCP)
    Tcl_CreateCommand( ip, "tcp", tcpCommand, (ClientData) NULL, NULL);
#endif
}
